<?php
/**
 * User
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  MawisApiClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Synchronizace údajů z Mawis.eu do endpointů (WebApi)
 *
 * **Popis api pro synchronizaci** dat z Wordpress (*Mawis.eu*) na jednotlivé endpointy (*UR/MWP*) na které se budou odesílat data o **registrovaných a upravených uživatelích a provedených nákupech**. Adresy endpointů se nastavují v konfiguraci WordPress, viz administrační příručka.
 *
 * The version of the OpenAPI document: 1.0
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.4.0
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace MawisApiClient\Model;

use \ArrayAccess;
use \MawisApiClient\ObjectSerializer;

/**
 * User Class Doc Comment
 *
 * @category Class
 * @package  MawisApiClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class User implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'User';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'lang_id' => 'int',
        'loginname' => 'string',
        'account_type' => 'string',
        'validity_from' => '\DateTime',
        'validity_to' => '\DateTime',
        'firstname' => 'string',
        'surname' => 'string',
        'titles' => 'string',
        'phone_prv' => 'string',
        'mobile_prv' => 'string',
        'email_prv' => 'string',
        'street_prv' => 'string',
        'number_prv' => 'string',
        'city_prv' => 'string',
        'zip_prv' => 'string',
        'country_id_prv' => 'int',
        'company' => 'string',
        'function_org' => 'string',
        'entity_org' => 'string',
        'street_org' => 'string',
        'number_org' => 'string',
        'city_org' => 'string',
        'zip_org' => 'string',
        'country_id_org' => 'int',
        'country_id' => 'int',
        'status' => 'string',
        'numberor_prv' => 'string',
        'numberor_org' => 'string',
        'in_code_id' => 'int',
        'ico_org' => 'string',
        'state_id' => '\MawisApiClient\Model\SUBSTStateId',
        'info' => 'string',
        'datereg' => '\DateTime',
        'autupd' => 'int',
        'datupd' => '\DateTime',
        'gdpr_consent' => 'string',
        'country_code_prv' => 'string',
        'country_code_org' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'lang_id' => null,
        'loginname' => null,
        'account_type' => null,
        'validity_from' => 'date-time',
        'validity_to' => 'date-time',
        'firstname' => null,
        'surname' => null,
        'titles' => null,
        'phone_prv' => null,
        'mobile_prv' => null,
        'email_prv' => null,
        'street_prv' => null,
        'number_prv' => null,
        'city_prv' => null,
        'zip_prv' => null,
        'country_id_prv' => null,
        'company' => null,
        'function_org' => null,
        'entity_org' => null,
        'street_org' => null,
        'number_org' => null,
        'city_org' => null,
        'zip_org' => null,
        'country_id_org' => null,
        'country_id' => null,
        'status' => null,
        'numberor_prv' => null,
        'numberor_org' => null,
        'in_code_id' => null,
        'ico_org' => null,
        'state_id' => null,
        'info' => null,
        'datereg' => 'date-time',
        'autupd' => null,
        'datupd' => 'date-time',
        'gdpr_consent' => null,
        'country_code_prv' => null,
        'country_code_org' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'id' => false,
		'lang_id' => false,
		'loginname' => false,
		'account_type' => false,
		'validity_from' => false,
		'validity_to' => false,
		'firstname' => false,
		'surname' => false,
		'titles' => false,
		'phone_prv' => false,
		'mobile_prv' => false,
		'email_prv' => false,
		'street_prv' => false,
		'number_prv' => false,
		'city_prv' => false,
		'zip_prv' => false,
		'country_id_prv' => false,
		'company' => false,
		'function_org' => false,
		'entity_org' => false,
		'street_org' => false,
		'number_org' => false,
		'city_org' => false,
		'zip_org' => false,
		'country_id_org' => false,
		'country_id' => false,
		'status' => false,
		'numberor_prv' => false,
		'numberor_org' => false,
		'in_code_id' => false,
		'ico_org' => false,
		'state_id' => false,
		'info' => false,
		'datereg' => false,
		'autupd' => false,
		'datupd' => false,
		'gdpr_consent' => false,
		'country_code_prv' => false,
		'country_code_org' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Setter - Array of nullable field names deliberately set to null
     *
     * @param boolean[] $openAPINullablesSetToNull
     */
    private function setOpenAPINullablesSetToNull(array $openAPINullablesSetToNull): void
    {
        $this->openAPINullablesSetToNull = $openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'ID',
        'lang_id' => 'LANG_ID',
        'loginname' => 'LOGINNAME',
        'account_type' => 'ACCOUNT_TYPE',
        'validity_from' => 'VALIDITY_FROM',
        'validity_to' => 'VALIDITY_TO',
        'firstname' => 'FIRSTNAME',
        'surname' => 'SURNAME',
        'titles' => 'TITLES',
        'phone_prv' => 'PHONE_PRV',
        'mobile_prv' => 'MOBILE_PRV',
        'email_prv' => 'EMAIL_PRV',
        'street_prv' => 'STREET_PRV',
        'number_prv' => 'NUMBER_PRV',
        'city_prv' => 'CITY_PRV',
        'zip_prv' => 'ZIP_PRV',
        'country_id_prv' => 'COUNTRY_ID_PRV',
        'company' => 'COMPANY',
        'function_org' => 'FUNCTION_ORG',
        'entity_org' => 'ENTITY_ORG',
        'street_org' => 'STREET_ORG',
        'number_org' => 'NUMBER_ORG',
        'city_org' => 'CITY_ORG',
        'zip_org' => 'ZIP_ORG',
        'country_id_org' => 'COUNTRY_ID_ORG',
        'country_id' => 'COUNTRY_ID',
        'status' => 'STATUS',
        'numberor_prv' => 'NUMBEROR_PRV',
        'numberor_org' => 'NUMBEROR_ORG',
        'in_code_id' => 'IN_CODE_ID',
        'ico_org' => 'ICO_ORG',
        'state_id' => 'STATE_ID',
        'info' => 'INFO',
        'datereg' => 'DATEREG',
        'autupd' => 'AUTUPD',
        'datupd' => 'DATUPD',
        'gdpr_consent' => 'GDPR_CONSENT',
        'country_code_prv' => 'COUNTRY_CODE_PRV',
        'country_code_org' => 'COUNTRY_CODE_ORG'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'lang_id' => 'setLangId',
        'loginname' => 'setLoginname',
        'account_type' => 'setAccountType',
        'validity_from' => 'setValidityFrom',
        'validity_to' => 'setValidityTo',
        'firstname' => 'setFirstname',
        'surname' => 'setSurname',
        'titles' => 'setTitles',
        'phone_prv' => 'setPhonePrv',
        'mobile_prv' => 'setMobilePrv',
        'email_prv' => 'setEmailPrv',
        'street_prv' => 'setStreetPrv',
        'number_prv' => 'setNumberPrv',
        'city_prv' => 'setCityPrv',
        'zip_prv' => 'setZipPrv',
        'country_id_prv' => 'setCountryIdPrv',
        'company' => 'setCompany',
        'function_org' => 'setFunctionOrg',
        'entity_org' => 'setEntityOrg',
        'street_org' => 'setStreetOrg',
        'number_org' => 'setNumberOrg',
        'city_org' => 'setCityOrg',
        'zip_org' => 'setZipOrg',
        'country_id_org' => 'setCountryIdOrg',
        'country_id' => 'setCountryId',
        'status' => 'setStatus',
        'numberor_prv' => 'setNumberorPrv',
        'numberor_org' => 'setNumberorOrg',
        'in_code_id' => 'setInCodeId',
        'ico_org' => 'setIcoOrg',
        'state_id' => 'setStateId',
        'info' => 'setInfo',
        'datereg' => 'setDatereg',
        'autupd' => 'setAutupd',
        'datupd' => 'setDatupd',
        'gdpr_consent' => 'setGdprConsent',
        'country_code_prv' => 'setCountryCodePrv',
        'country_code_org' => 'setCountryCodeOrg'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'lang_id' => 'getLangId',
        'loginname' => 'getLoginname',
        'account_type' => 'getAccountType',
        'validity_from' => 'getValidityFrom',
        'validity_to' => 'getValidityTo',
        'firstname' => 'getFirstname',
        'surname' => 'getSurname',
        'titles' => 'getTitles',
        'phone_prv' => 'getPhonePrv',
        'mobile_prv' => 'getMobilePrv',
        'email_prv' => 'getEmailPrv',
        'street_prv' => 'getStreetPrv',
        'number_prv' => 'getNumberPrv',
        'city_prv' => 'getCityPrv',
        'zip_prv' => 'getZipPrv',
        'country_id_prv' => 'getCountryIdPrv',
        'company' => 'getCompany',
        'function_org' => 'getFunctionOrg',
        'entity_org' => 'getEntityOrg',
        'street_org' => 'getStreetOrg',
        'number_org' => 'getNumberOrg',
        'city_org' => 'getCityOrg',
        'zip_org' => 'getZipOrg',
        'country_id_org' => 'getCountryIdOrg',
        'country_id' => 'getCountryId',
        'status' => 'getStatus',
        'numberor_prv' => 'getNumberorPrv',
        'numberor_org' => 'getNumberorOrg',
        'in_code_id' => 'getInCodeId',
        'ico_org' => 'getIcoOrg',
        'state_id' => 'getStateId',
        'info' => 'getInfo',
        'datereg' => 'getDatereg',
        'autupd' => 'getAutupd',
        'datupd' => 'getDatupd',
        'gdpr_consent' => 'getGdprConsent',
        'country_code_prv' => 'getCountryCodePrv',
        'country_code_org' => 'getCountryCodeOrg'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const ACCOUNT_TYPE_P = 'P';
    public const ACCOUNT_TYPE_C = 'C';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountTypeAllowableValues()
    {
        return [
            self::ACCOUNT_TYPE_P,
            self::ACCOUNT_TYPE_C,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data ?? [], null);
        $this->setIfExists('lang_id', $data ?? [], null);
        $this->setIfExists('loginname', $data ?? [], null);
        $this->setIfExists('account_type', $data ?? [], null);
        $this->setIfExists('validity_from', $data ?? [], null);
        $this->setIfExists('validity_to', $data ?? [], null);
        $this->setIfExists('firstname', $data ?? [], null);
        $this->setIfExists('surname', $data ?? [], null);
        $this->setIfExists('titles', $data ?? [], null);
        $this->setIfExists('phone_prv', $data ?? [], null);
        $this->setIfExists('mobile_prv', $data ?? [], null);
        $this->setIfExists('email_prv', $data ?? [], null);
        $this->setIfExists('street_prv', $data ?? [], null);
        $this->setIfExists('number_prv', $data ?? [], null);
        $this->setIfExists('city_prv', $data ?? [], null);
        $this->setIfExists('zip_prv', $data ?? [], null);
        $this->setIfExists('country_id_prv', $data ?? [], null);
        $this->setIfExists('company', $data ?? [], null);
        $this->setIfExists('function_org', $data ?? [], null);
        $this->setIfExists('entity_org', $data ?? [], null);
        $this->setIfExists('street_org', $data ?? [], null);
        $this->setIfExists('number_org', $data ?? [], null);
        $this->setIfExists('city_org', $data ?? [], null);
        $this->setIfExists('zip_org', $data ?? [], null);
        $this->setIfExists('country_id_org', $data ?? [], null);
        $this->setIfExists('country_id', $data ?? [], null);
        $this->setIfExists('status', $data ?? [], null);
        $this->setIfExists('numberor_prv', $data ?? [], null);
        $this->setIfExists('numberor_org', $data ?? [], null);
        $this->setIfExists('in_code_id', $data ?? [], null);
        $this->setIfExists('ico_org', $data ?? [], null);
        $this->setIfExists('state_id', $data ?? [], null);
        $this->setIfExists('info', $data ?? [], null);
        $this->setIfExists('datereg', $data ?? [], null);
        $this->setIfExists('autupd', $data ?? [], null);
        $this->setIfExists('datupd', $data ?? [], null);
        $this->setIfExists('gdpr_consent', $data ?? [], null);
        $this->setIfExists('country_code_prv', $data ?? [], null);
        $this->setIfExists('country_code_org', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['lang_id'] === null) {
            $invalidProperties[] = "'lang_id' can't be null";
        }
        if ($this->container['loginname'] === null) {
            $invalidProperties[] = "'loginname' can't be null";
        }
        if ((mb_strlen($this->container['loginname']) > 30)) {
            $invalidProperties[] = "invalid value for 'loginname', the character length must be smaller than or equal to 30.";
        }

        $allowedValues = $this->getAccountTypeAllowableValues();
        if (!is_null($this->container['account_type']) && !in_array($this->container['account_type'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'account_type', must be one of '%s'",
                $this->container['account_type'],
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['account_type']) && (mb_strlen($this->container['account_type']) > 1)) {
            $invalidProperties[] = "invalid value for 'account_type', the character length must be smaller than or equal to 1.";
        }

        if (!is_null($this->container['account_type']) && (mb_strlen($this->container['account_type']) < 1)) {
            $invalidProperties[] = "invalid value for 'account_type', the character length must be bigger than or equal to 1.";
        }

        if ($this->container['firstname'] === null) {
            $invalidProperties[] = "'firstname' can't be null";
        }
        if ((mb_strlen($this->container['firstname']) > 50)) {
            $invalidProperties[] = "invalid value for 'firstname', the character length must be smaller than or equal to 50.";
        }

        if ($this->container['surname'] === null) {
            $invalidProperties[] = "'surname' can't be null";
        }
        if ((mb_strlen($this->container['surname']) > 50)) {
            $invalidProperties[] = "invalid value for 'surname', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['titles']) && (mb_strlen($this->container['titles']) > 30)) {
            $invalidProperties[] = "invalid value for 'titles', the character length must be smaller than or equal to 30.";
        }

        if (!is_null($this->container['phone_prv']) && (mb_strlen($this->container['phone_prv']) > 50)) {
            $invalidProperties[] = "invalid value for 'phone_prv', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['mobile_prv']) && (mb_strlen($this->container['mobile_prv']) > 50)) {
            $invalidProperties[] = "invalid value for 'mobile_prv', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['email_prv']) && (mb_strlen($this->container['email_prv']) > 40)) {
            $invalidProperties[] = "invalid value for 'email_prv', the character length must be smaller than or equal to 40.";
        }

        if (!is_null($this->container['street_prv']) && (mb_strlen($this->container['street_prv']) > 50)) {
            $invalidProperties[] = "invalid value for 'street_prv', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['number_prv']) && (mb_strlen($this->container['number_prv']) > 15)) {
            $invalidProperties[] = "invalid value for 'number_prv', the character length must be smaller than or equal to 15.";
        }

        if (!is_null($this->container['city_prv']) && (mb_strlen($this->container['city_prv']) > 50)) {
            $invalidProperties[] = "invalid value for 'city_prv', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['zip_prv']) && (mb_strlen($this->container['zip_prv']) > 10)) {
            $invalidProperties[] = "invalid value for 'zip_prv', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['company']) && (mb_strlen($this->container['company']) > 100)) {
            $invalidProperties[] = "invalid value for 'company', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['function_org']) && (mb_strlen($this->container['function_org']) > 100)) {
            $invalidProperties[] = "invalid value for 'function_org', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['entity_org']) && (mb_strlen($this->container['entity_org']) > 50)) {
            $invalidProperties[] = "invalid value for 'entity_org', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['street_org']) && (mb_strlen($this->container['street_org']) > 50)) {
            $invalidProperties[] = "invalid value for 'street_org', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['number_org']) && (mb_strlen($this->container['number_org']) > 15)) {
            $invalidProperties[] = "invalid value for 'number_org', the character length must be smaller than or equal to 15.";
        }

        if (!is_null($this->container['city_org']) && (mb_strlen($this->container['city_org']) > 50)) {
            $invalidProperties[] = "invalid value for 'city_org', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['zip_org']) && (mb_strlen($this->container['zip_org']) > 10)) {
            $invalidProperties[] = "invalid value for 'zip_org', the character length must be smaller than or equal to 10.";
        }

        if ($this->container['status'] === null) {
            $invalidProperties[] = "'status' can't be null";
        }
        if ((mb_strlen($this->container['status']) > 1)) {
            $invalidProperties[] = "invalid value for 'status', the character length must be smaller than or equal to 1.";
        }

        if (!is_null($this->container['numberor_prv']) && (mb_strlen($this->container['numberor_prv']) > 15)) {
            $invalidProperties[] = "invalid value for 'numberor_prv', the character length must be smaller than or equal to 15.";
        }

        if (!is_null($this->container['ico_org']) && (mb_strlen($this->container['ico_org']) > 10)) {
            $invalidProperties[] = "invalid value for 'ico_org', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['info']) && (mb_strlen($this->container['info']) > 1)) {
            $invalidProperties[] = "invalid value for 'info', the character length must be smaller than or equal to 1.";
        }

        if ($this->container['gdpr_consent'] === null) {
            $invalidProperties[] = "'gdpr_consent' can't be null";
        }
        if ((mb_strlen($this->container['gdpr_consent']) > 1)) {
            $invalidProperties[] = "invalid value for 'gdpr_consent', the character length must be smaller than or equal to 1.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id ID uživatele
     *
     * @return self
     */
    public function setId($id)
    {
        if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets lang_id
     *
     * @return int
     */
    public function getLangId()
    {
        return $this->container['lang_id'];
    }

    /**
     * Sets lang_id
     *
     * @param int $lang_id Jazyk uživatele Požadované výchozí nastavení jazykové mutace aplikace. Z číselníku (tabulka wp_cis_language).
     *
     * @return self
     */
    public function setLangId($lang_id)
    {
        if (is_null($lang_id)) {
            throw new \InvalidArgumentException('non-nullable lang_id cannot be null');
        }
        $this->container['lang_id'] = $lang_id;

        return $this;
    }

    /**
     * Gets loginname
     *
     * @return string
     */
    public function getLoginname()
    {
        return $this->container['loginname'];
    }

    /**
     * Sets loginname
     *
     * @param string $loginname Přihlašovací jméno
     *
     * @return self
     */
    public function setLoginname($loginname)
    {
        if (is_null($loginname)) {
            throw new \InvalidArgumentException('non-nullable loginname cannot be null');
        }
        if ((mb_strlen($loginname) > 30)) {
            throw new \InvalidArgumentException('invalid length for $loginname when calling User., must be smaller than or equal to 30.');
        }

        $this->container['loginname'] = $loginname;

        return $this;
    }

    /**
     * Gets account_type
     *
     * @return string|null
     */
    public function getAccountType()
    {
        return $this->container['account_type'];
    }

    /**
     * Sets account_type
     *
     * @param string|null $account_type * Typ účtu * P - soukromý účet #?vrací se vždy jenom P? * C - veřejný účet
     *
     * @return self
     */
    public function setAccountType($account_type)
    {
        if (is_null($account_type)) {
            throw new \InvalidArgumentException('non-nullable account_type cannot be null');
        }
        $allowedValues = $this->getAccountTypeAllowableValues();
        if (!in_array($account_type, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'account_type', must be one of '%s'",
                    $account_type,
                    implode("', '", $allowedValues)
                )
            );
        }
        if ((mb_strlen($account_type) > 1)) {
            throw new \InvalidArgumentException('invalid length for $account_type when calling User., must be smaller than or equal to 1.');
        }
        if ((mb_strlen($account_type) < 1)) {
            throw new \InvalidArgumentException('invalid length for $account_type when calling User., must be bigger than or equal to 1.');
        }

        $this->container['account_type'] = $account_type;

        return $this;
    }

    /**
     * Gets validity_from
     *
     * @return \DateTime|null
     */
    public function getValidityFrom()
    {
        return $this->container['validity_from'];
    }

    /**
     * Sets validity_from
     *
     * @param \DateTime|null $validity_from Datum, od kdy je účet platný
     *
     * @return self
     */
    public function setValidityFrom($validity_from)
    {
        if (is_null($validity_from)) {
            throw new \InvalidArgumentException('non-nullable validity_from cannot be null');
        }
        $this->container['validity_from'] = $validity_from;

        return $this;
    }

    /**
     * Gets validity_to
     *
     * @return \DateTime|null
     */
    public function getValidityTo()
    {
        return $this->container['validity_to'];
    }

    /**
     * Sets validity_to
     *
     * @param \DateTime|null $validity_to Datum, do kdy je účet platný
     *
     * @return self
     */
    public function setValidityTo($validity_to)
    {
        if (is_null($validity_to)) {
            throw new \InvalidArgumentException('non-nullable validity_to cannot be null');
        }
        $this->container['validity_to'] = $validity_to;

        return $this;
    }

    /**
     * Gets firstname
     *
     * @return string
     */
    public function getFirstname()
    {
        return $this->container['firstname'];
    }

    /**
     * Sets firstname
     *
     * @param string $firstname Jméno
     *
     * @return self
     */
    public function setFirstname($firstname)
    {
        if (is_null($firstname)) {
            throw new \InvalidArgumentException('non-nullable firstname cannot be null');
        }
        if ((mb_strlen($firstname) > 50)) {
            throw new \InvalidArgumentException('invalid length for $firstname when calling User., must be smaller than or equal to 50.');
        }

        $this->container['firstname'] = $firstname;

        return $this;
    }

    /**
     * Gets surname
     *
     * @return string
     */
    public function getSurname()
    {
        return $this->container['surname'];
    }

    /**
     * Sets surname
     *
     * @param string $surname Příjmení
     *
     * @return self
     */
    public function setSurname($surname)
    {
        if (is_null($surname)) {
            throw new \InvalidArgumentException('non-nullable surname cannot be null');
        }
        if ((mb_strlen($surname) > 50)) {
            throw new \InvalidArgumentException('invalid length for $surname when calling User., must be smaller than or equal to 50.');
        }

        $this->container['surname'] = $surname;

        return $this;
    }

    /**
     * Gets titles
     *
     * @return string|null
     */
    public function getTitles()
    {
        return $this->container['titles'];
    }

    /**
     * Sets titles
     *
     * @param string|null $titles Akademický <strong>titul</strong>
     *
     * @return self
     */
    public function setTitles($titles)
    {
        if (is_null($titles)) {
            throw new \InvalidArgumentException('non-nullable titles cannot be null');
        }
        if ((mb_strlen($titles) > 30)) {
            throw new \InvalidArgumentException('invalid length for $titles when calling User., must be smaller than or equal to 30.');
        }

        $this->container['titles'] = $titles;

        return $this;
    }

    /**
     * Gets phone_prv
     *
     * @return string|null
     */
    public function getPhonePrv()
    {
        return $this->container['phone_prv'];
    }

    /**
     * Sets phone_prv
     *
     * @param string|null $phone_prv Telefon - Odesílá se vždy \"null\"
     *
     * @return self
     */
    public function setPhonePrv($phone_prv)
    {
        if (is_null($phone_prv)) {
            throw new \InvalidArgumentException('non-nullable phone_prv cannot be null');
        }
        if ((mb_strlen($phone_prv) > 50)) {
            throw new \InvalidArgumentException('invalid length for $phone_prv when calling User., must be smaller than or equal to 50.');
        }

        $this->container['phone_prv'] = $phone_prv;

        return $this;
    }

    /**
     * Gets mobile_prv
     *
     * @return string|null
     */
    public function getMobilePrv()
    {
        return $this->container['mobile_prv'];
    }

    /**
     * Sets mobile_prv
     *
     * @param string|null $mobile_prv Mobil
     *
     * @return self
     */
    public function setMobilePrv($mobile_prv)
    {
        if (is_null($mobile_prv)) {
            throw new \InvalidArgumentException('non-nullable mobile_prv cannot be null');
        }
        if ((mb_strlen($mobile_prv) > 50)) {
            throw new \InvalidArgumentException('invalid length for $mobile_prv when calling User., must be smaller than or equal to 50.');
        }

        $this->container['mobile_prv'] = $mobile_prv;

        return $this;
    }

    /**
     * Gets email_prv
     *
     * @return string|null
     */
    public function getEmailPrv()
    {
        return $this->container['email_prv'];
    }

    /**
     * Sets email_prv
     *
     * @param string|null $email_prv E-mail
     *
     * @return self
     */
    public function setEmailPrv($email_prv)
    {
        if (is_null($email_prv)) {
            throw new \InvalidArgumentException('non-nullable email_prv cannot be null');
        }
        if ((mb_strlen($email_prv) > 40)) {
            throw new \InvalidArgumentException('invalid length for $email_prv when calling User., must be smaller than or equal to 40.');
        }

        $this->container['email_prv'] = $email_prv;

        return $this;
    }

    /**
     * Gets street_prv
     *
     * @return string|null
     */
    public function getStreetPrv()
    {
        return $this->container['street_prv'];
    }

    /**
     * Sets street_prv
     *
     * @param string|null $street_prv Korespondenční adresa - Ulice/část obce
     *
     * @return self
     */
    public function setStreetPrv($street_prv)
    {
        if (is_null($street_prv)) {
            throw new \InvalidArgumentException('non-nullable street_prv cannot be null');
        }
        if ((mb_strlen($street_prv) > 50)) {
            throw new \InvalidArgumentException('invalid length for $street_prv when calling User., must be smaller than or equal to 50.');
        }

        $this->container['street_prv'] = $street_prv;

        return $this;
    }

    /**
     * Gets number_prv
     *
     * @return string|null
     */
    public function getNumberPrv()
    {
        return $this->container['number_prv'];
    }

    /**
     * Sets number_prv
     *
     * @param string|null $number_prv Korespondenční adresa - Číslo domovní
     *
     * @return self
     */
    public function setNumberPrv($number_prv)
    {
        if (is_null($number_prv)) {
            throw new \InvalidArgumentException('non-nullable number_prv cannot be null');
        }
        if ((mb_strlen($number_prv) > 15)) {
            throw new \InvalidArgumentException('invalid length for $number_prv when calling User., must be smaller than or equal to 15.');
        }

        $this->container['number_prv'] = $number_prv;

        return $this;
    }

    /**
     * Gets city_prv
     *
     * @return string|null
     */
    public function getCityPrv()
    {
        return $this->container['city_prv'];
    }

    /**
     * Sets city_prv
     *
     * @param string|null $city_prv Korespondenční adresa - Obec
     *
     * @return self
     */
    public function setCityPrv($city_prv)
    {
        if (is_null($city_prv)) {
            throw new \InvalidArgumentException('non-nullable city_prv cannot be null');
        }
        if ((mb_strlen($city_prv) > 50)) {
            throw new \InvalidArgumentException('invalid length for $city_prv when calling User., must be smaller than or equal to 50.');
        }

        $this->container['city_prv'] = $city_prv;

        return $this;
    }

    /**
     * Gets zip_prv
     *
     * @return string|null
     */
    public function getZipPrv()
    {
        return $this->container['zip_prv'];
    }

    /**
     * Sets zip_prv
     *
     * @param string|null $zip_prv Korespondenční adresa - PSČ
     *
     * @return self
     */
    public function setZipPrv($zip_prv)
    {
        if (is_null($zip_prv)) {
            throw new \InvalidArgumentException('non-nullable zip_prv cannot be null');
        }
        if ((mb_strlen($zip_prv) > 10)) {
            throw new \InvalidArgumentException('invalid length for $zip_prv when calling User., must be smaller than or equal to 10.');
        }

        $this->container['zip_prv'] = $zip_prv;

        return $this;
    }

    /**
     * Gets country_id_prv
     *
     * @return int|null
     */
    public function getCountryIdPrv()
    {
        return $this->container['country_id_prv'];
    }

    /**
     * Sets country_id_prv
     *
     * @param int|null $country_id_prv Korespondenční adresa - Stát Odesílá se vždy \"null\". Dříve se odesílal kód 203 dle jednoznačného idenitfikace státu. Nově se využívá atribut COUNTRY_CODE_PRV, kde se posílá CODE2 kompatiblní s Woocommerce pluginem WP.
     *
     * @return self
     */
    public function setCountryIdPrv($country_id_prv)
    {
        if (is_null($country_id_prv)) {
            throw new \InvalidArgumentException('non-nullable country_id_prv cannot be null');
        }
        $this->container['country_id_prv'] = $country_id_prv;

        return $this;
    }

    /**
     * Gets company
     *
     * @return string|null
     */
    public function getCompany()
    {
        return $this->container['company'];
    }

    /**
     * Sets company
     *
     * @param string|null $company Základní údaje o subjektu - Název subjektu
     *
     * @return self
     */
    public function setCompany($company)
    {
        if (is_null($company)) {
            throw new \InvalidArgumentException('non-nullable company cannot be null');
        }
        if ((mb_strlen($company) > 100)) {
            throw new \InvalidArgumentException('invalid length for $company when calling User., must be smaller than or equal to 100.');
        }

        $this->container['company'] = $company;

        return $this;
    }

    /**
     * Gets function_org
     *
     * @return string|null
     */
    public function getFunctionOrg()
    {
        return $this->container['function_org'];
    }

    /**
     * Sets function_org
     *
     * @param string|null $function_org Funkce uživatele v organizaci - Odesílá se vždy \"null\"
     *
     * @return self
     */
    public function setFunctionOrg($function_org)
    {
        if (is_null($function_org)) {
            throw new \InvalidArgumentException('non-nullable function_org cannot be null');
        }
        if ((mb_strlen($function_org) > 100)) {
            throw new \InvalidArgumentException('invalid length for $function_org when calling User., must be smaller than or equal to 100.');
        }

        $this->container['function_org'] = $function_org;

        return $this;
    }

    /**
     * Gets entity_org
     *
     * @return string|null
     */
    public function getEntityOrg()
    {
        return $this->container['entity_org'];
    }

    /**
     * Sets entity_org
     *
     * @param string|null $entity_org Útvar v organizaci, do kterého je uživatel zařazen - Odesílá se vždy \"null\"
     *
     * @return self
     */
    public function setEntityOrg($entity_org)
    {
        if (is_null($entity_org)) {
            throw new \InvalidArgumentException('non-nullable entity_org cannot be null');
        }
        if ((mb_strlen($entity_org) > 50)) {
            throw new \InvalidArgumentException('invalid length for $entity_org when calling User., must be smaller than or equal to 50.');
        }

        $this->container['entity_org'] = $entity_org;

        return $this;
    }

    /**
     * Gets street_org
     *
     * @return string|null
     */
    public function getStreetOrg()
    {
        return $this->container['street_org'];
    }

    /**
     * Sets street_org
     *
     * @param string|null $street_org Fakturační adresa - Ulice/část obce
     *
     * @return self
     */
    public function setStreetOrg($street_org)
    {
        if (is_null($street_org)) {
            throw new \InvalidArgumentException('non-nullable street_org cannot be null');
        }
        if ((mb_strlen($street_org) > 50)) {
            throw new \InvalidArgumentException('invalid length for $street_org when calling User., must be smaller than or equal to 50.');
        }

        $this->container['street_org'] = $street_org;

        return $this;
    }

    /**
     * Gets number_org
     *
     * @return string|null
     */
    public function getNumberOrg()
    {
        return $this->container['number_org'];
    }

    /**
     * Sets number_org
     *
     * @param string|null $number_org Fakturační adresa - Číslo domovní
     *
     * @return self
     */
    public function setNumberOrg($number_org)
    {
        if (is_null($number_org)) {
            throw new \InvalidArgumentException('non-nullable number_org cannot be null');
        }
        if ((mb_strlen($number_org) > 15)) {
            throw new \InvalidArgumentException('invalid length for $number_org when calling User., must be smaller than or equal to 15.');
        }

        $this->container['number_org'] = $number_org;

        return $this;
    }

    /**
     * Gets city_org
     *
     * @return string|null
     */
    public function getCityOrg()
    {
        return $this->container['city_org'];
    }

    /**
     * Sets city_org
     *
     * @param string|null $city_org Fakturační adresa - Obec
     *
     * @return self
     */
    public function setCityOrg($city_org)
    {
        if (is_null($city_org)) {
            throw new \InvalidArgumentException('non-nullable city_org cannot be null');
        }
        if ((mb_strlen($city_org) > 50)) {
            throw new \InvalidArgumentException('invalid length for $city_org when calling User., must be smaller than or equal to 50.');
        }

        $this->container['city_org'] = $city_org;

        return $this;
    }

    /**
     * Gets zip_org
     *
     * @return string|null
     */
    public function getZipOrg()
    {
        return $this->container['zip_org'];
    }

    /**
     * Sets zip_org
     *
     * @param string|null $zip_org Fakturační adresa - PSČ
     *
     * @return self
     */
    public function setZipOrg($zip_org)
    {
        if (is_null($zip_org)) {
            throw new \InvalidArgumentException('non-nullable zip_org cannot be null');
        }
        if ((mb_strlen($zip_org) > 10)) {
            throw new \InvalidArgumentException('invalid length for $zip_org when calling User., must be smaller than or equal to 10.');
        }

        $this->container['zip_org'] = $zip_org;

        return $this;
    }

    /**
     * Gets country_id_org
     *
     * @return int|null
     */
    public function getCountryIdOrg()
    {
        return $this->container['country_id_org'];
    }

    /**
     * Sets country_id_org
     *
     * @param int|null $country_id_org Fakturační adresa - Stát - Odesílá se vždy \"null\". Dříve se odesílal kód 203 dle jednoznačného idenitfikace státu. Nově se využívá atribut COUNTRY_CODE_ORG, kde se posílá CODE2 kompatiblní s Woocommerce pluginem WP.
     *
     * @return self
     */
    public function setCountryIdOrg($country_id_org)
    {
        if (is_null($country_id_org)) {
            throw new \InvalidArgumentException('non-nullable country_id_org cannot be null');
        }
        $this->container['country_id_org'] = $country_id_org;

        return $this;
    }

    /**
     * Gets country_id
     *
     * @return int|null
     */
    public function getCountryId()
    {
        return $this->container['country_id'];
    }

    /**
     * Sets country_id
     *
     * @param int|null $country_id Země registrace - Odesílá se jednoznačná identifikace státu z číselníku (tabulka wp_cis_country) nebo null pokud se nejedná o právnickou osobu a nemá tedy nastavenou zemi registrace. Identifikace základních údajů o subjektu pro právnickou osobu, dotahování dat z ARES pro 203/CZ[ČR]).
     *
     * @return self
     */
    public function setCountryId($country_id)
    {
        if (is_null($country_id)) {
            throw new \InvalidArgumentException('non-nullable country_id cannot be null');
        }
        $this->container['country_id'] = $country_id;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status Stav uživatelského účtu. 'A' - aktivní, lze ho použít pro přihlášení 'N' - neaktivní, nelze ho použít pro přihlášení **Odesílá se vždy 'A'**
     *
     * @return self
     */
    public function setStatus($status)
    {
        if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }
        if ((mb_strlen($status) > 1)) {
            throw new \InvalidArgumentException('invalid length for $status when calling User., must be smaller than or equal to 1.');
        }

        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets numberor_prv
     *
     * @return string|null
     */
    public function getNumberorPrv()
    {
        return $this->container['numberor_prv'];
    }

    /**
     * Sets numberor_prv
     *
     * @param string|null $numberor_prv Korespondenční adreasa - Číslo orientační
     *
     * @return self
     */
    public function setNumberorPrv($numberor_prv)
    {
        if (is_null($numberor_prv)) {
            throw new \InvalidArgumentException('non-nullable numberor_prv cannot be null');
        }
        if ((mb_strlen($numberor_prv) > 15)) {
            throw new \InvalidArgumentException('invalid length for $numberor_prv when calling User., must be smaller than or equal to 15.');
        }

        $this->container['numberor_prv'] = $numberor_prv;

        return $this;
    }

    /**
     * Gets numberor_org
     *
     * @return string|null
     */
    public function getNumberorOrg()
    {
        return $this->container['numberor_org'];
    }

    /**
     * Sets numberor_org
     *
     * @param string|null $numberor_org Fakturační adresa - Číslo orientační
     *
     * @return self
     */
    public function setNumberorOrg($numberor_org)
    {
        if (is_null($numberor_org)) {
            throw new \InvalidArgumentException('non-nullable numberor_org cannot be null');
        }
        $this->container['numberor_org'] = $numberor_org;

        return $this;
    }

    /**
     * Gets in_code_id
     *
     * @return int|null
     */
    public function getInCodeId()
    {
        return $this->container['in_code_id'];
    }

    /**
     * Sets in_code_id
     *
     * @param int|null $in_code_id ID vstupního bodu - je povinně vyplněn pro všechny veřejné uživatele (obce/města, správce) resp. nikdy není vyplněn pro privátního (registrovaného) uživatele  Vstupní bod UR - Z číselníku (tabulka wp_in_code)
     *
     * @return self
     */
    public function setInCodeId($in_code_id)
    {
        if (is_null($in_code_id)) {
            throw new \InvalidArgumentException('non-nullable in_code_id cannot be null');
        }
        $this->container['in_code_id'] = $in_code_id;

        return $this;
    }

    /**
     * Gets ico_org
     *
     * @return string|null
     */
    public function getIcoOrg()
    {
        return $this->container['ico_org'];
    }

    /**
     * Sets ico_org
     *
     * @param string|null $ico_org Základní údaje o subjektu - IČO
     *
     * @return self
     */
    public function setIcoOrg($ico_org)
    {
        if (is_null($ico_org)) {
            throw new \InvalidArgumentException('non-nullable ico_org cannot be null');
        }
        if ((mb_strlen($ico_org) > 10)) {
            throw new \InvalidArgumentException('invalid length for $ico_org when calling User., must be smaller than or equal to 10.');
        }

        $this->container['ico_org'] = $ico_org;

        return $this;
    }

    /**
     * Gets state_id
     *
     * @return \MawisApiClient\Model\SUBSTStateId|null
     */
    public function getStateId()
    {
        return $this->container['state_id'];
    }

    /**
     * Sets state_id
     *
     * @param \MawisApiClient\Model\SUBSTStateId|null $state_id state_id
     *
     * @return self
     */
    public function setStateId($state_id)
    {
        if (is_null($state_id)) {
            throw new \InvalidArgumentException('non-nullable state_id cannot be null');
        }
        $this->container['state_id'] = $state_id;

        return $this;
    }

    /**
     * Gets info
     *
     * @return string|null
     */
    public function getInfo()
    {
        return $this->container['info'];
    }

    /**
     * Sets info
     *
     * @param string|null $info Informace, zda uživatel při registraci (nebo následně) povolil resp. nepovolil zasílání obchodních sdělení (A = zasílání je povoleno, N = není povoleno)| Odesílá se vždy \"null\"
     *
     * @return self
     */
    public function setInfo($info)
    {
        if (is_null($info)) {
            throw new \InvalidArgumentException('non-nullable info cannot be null');
        }
        if ((mb_strlen($info) > 1)) {
            throw new \InvalidArgumentException('invalid length for $info when calling User., must be smaller than or equal to 1.');
        }

        $this->container['info'] = $info;

        return $this;
    }

    /**
     * Gets datereg
     *
     * @return \DateTime|null
     */
    public function getDatereg()
    {
        return $this->container['datereg'];
    }

    /**
     * Sets datereg
     *
     * @param \DateTime|null $datereg Datum registrace
     *
     * @return self
     */
    public function setDatereg($datereg)
    {
        if (is_null($datereg)) {
            throw new \InvalidArgumentException('non-nullable datereg cannot be null');
        }
        $this->container['datereg'] = $datereg;

        return $this;
    }

    /**
     * Gets autupd
     *
     * @return int|null
     */
    public function getAutupd()
    {
        return $this->container['autupd'];
    }

    /**
     * Sets autupd
     *
     * @param int|null $autupd ID uživatele provedené změny
     *
     * @return self
     */
    public function setAutupd($autupd)
    {
        if (is_null($autupd)) {
            throw new \InvalidArgumentException('non-nullable autupd cannot be null');
        }
        $this->container['autupd'] = $autupd;

        return $this;
    }

    /**
     * Gets datupd
     *
     * @return \DateTime|null
     */
    public function getDatupd()
    {
        return $this->container['datupd'];
    }

    /**
     * Sets datupd
     *
     * @param \DateTime|null $datupd Datum změny
     *
     * @return self
     */
    public function setDatupd($datupd)
    {
        if (is_null($datupd)) {
            throw new \InvalidArgumentException('non-nullable datupd cannot be null');
        }
        $this->container['datupd'] = $datupd;

        return $this;
    }

    /**
     * Gets gdpr_consent
     *
     * @return string
     */
    public function getGdprConsent()
    {
        return $this->container['gdpr_consent'];
    }

    /**
     * Sets gdpr_consent
     *
     * @param string $gdpr_consent Souhlas s GDPR A - ano; N - ne
     *
     * @return self
     */
    public function setGdprConsent($gdpr_consent)
    {
        if (is_null($gdpr_consent)) {
            throw new \InvalidArgumentException('non-nullable gdpr_consent cannot be null');
        }
        if ((mb_strlen($gdpr_consent) > 1)) {
            throw new \InvalidArgumentException('invalid length for $gdpr_consent when calling User., must be smaller than or equal to 1.');
        }

        $this->container['gdpr_consent'] = $gdpr_consent;

        return $this;
    }

    /**
     * Gets country_code_prv
     *
     * @return string|null
     */
    public function getCountryCodePrv()
    {
        return $this->container['country_code_prv'];
    }

    /**
     * Sets country_code_prv
     *
     * @param string|null $country_code_prv Korespondenční adresa - Stát | Odesílá se CODE2
     *
     * @return self
     */
    public function setCountryCodePrv($country_code_prv)
    {
        if (is_null($country_code_prv)) {
            throw new \InvalidArgumentException('non-nullable country_code_prv cannot be null');
        }
        $this->container['country_code_prv'] = $country_code_prv;

        return $this;
    }

    /**
     * Gets country_code_org
     *
     * @return string|null
     */
    public function getCountryCodeOrg()
    {
        return $this->container['country_code_org'];
    }

    /**
     * Sets country_code_org
     *
     * @param string|null $country_code_org Fakturační adresa - Stát | Odesílá se CODE2
     *
     * @return self
     */
    public function setCountryCodeOrg($country_code_org)
    {
        if (is_null($country_code_org)) {
            throw new \InvalidArgumentException('non-nullable country_code_org cannot be null');
        }
        $this->container['country_code_org'] = $country_code_org;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


